Imports System.Data.SqlClient
Imports System.Data
Imports System.Net.Mail

Partial Class Fortgot_password
    Inherits System.Web.UI.Page

    Protected Sub btnNewPassword_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnNewPassword.Click

        ' We first declare one variable that will store a username that we selected from the Customers table.

        Dim lookupUsername As String
        lookupUsername = ""
        ErrorMessage.Text = ""

        ' We select the username that corresponds to the supplied e-mail adress in the "txtEmail" textbox and
        ' then add this selected username to the "lookupUsername" string.

        Try
            Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
            Dim sql As String = "SELECT Username FROM Customers WHERE Username=@username"

            ' The Using block is used to call dispose (close) automatically even if there are an exception.
            Using cn As New SqlConnection(ConnString), _
                  cmd As New SqlCommand(sql, cn)
                cmd.Parameters.Add("@username", SqlDbType.VarChar, 80).Value = txtEmail.Text

                cn.Open()

                ' Execute the select command and set a value for lookupUsername.
                lookupUsername = Convert.ToString(cmd.ExecuteScalar())

            End Using
        Catch Sqlex As SqlException
            Response.Write(Sqlex.Message)
        Catch ex As Exception
            Response.Write(ex.Message)
        End Try


        ' We check if the selected username from the Customers table are equal to the supplied e-mail adress in the
        ' "txtEmail" textbox and create a error message there is no match between them.

        If lookupUsername = txtEmail.Text Then

            ' We generate a new random password with the "generatePassword()" function and then hash this password
            ' with SHA1 to store an encrypted password in the "Customers" table.

            Dim passwordHash As String
            Dim NewPassword As String = generatePassword()

            passwordHash = FormsAuthentication.HashPasswordForStoringInConfigFile(NewPassword, "SHA1")

            ' We update the password in the Customers table for the user that have requested to get a new
            ' password with the encrypted version of our newly created password.

            Try
                Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
                Dim sql As String = "UPDATE Customers SET Password = @Password WHERE Username = @Username"

                ' The Using block is used to call dispose (close) automatically even if there are an exception.
                Using cn As New SqlConnection(ConnString), _
                      cmd As New SqlCommand(sql, cn)
                    cmd.Parameters.Add("@Username", SqlDbType.VarChar, 80).Value = lookupUsername
                    cmd.Parameters.Add("@Password", SqlDbType.VarChar, 40).Value = passwordHash

                    cn.Open()
                    cmd.ExecuteNonQuery()

                End Using
            Catch ex As Exception
                Response.Write(ex.Message)
            End Try

            ' Next we are about to send an email to the e-mail adress that we have selected from the "Customers" table.
            ' We declare the email adress to send the e-mail to.

            Dim ToAddress As String = lookupUsername

            ' We create the mail message.

            Dim SendEmail As New MailMessage("info@mywebshop.com", ToAddress)

            ' We add subject an body to the mail message.

            SendEmail.Subject = "New password to MyWebshop.com"
            SendEmail.Body = "<html><body><b>Hi!</b><br />You receive this e-mail with a new password because of your request to get a new password.<br /><br />" & "Your new password:" & " " & NewPassword & "</body></html>"
            SendEmail.IsBodyHtml = True

            ' Send the e-mail (see the web.config settings for e-mail)

            Dim smtp As New SmtpClient
            smtp.Send(SendEmail)

            ' Set visibilites for panels to give the user a confirmation

            NewPasswordPanel.Visible = False
            ConfirmationPanel.Visible = True

        Else
            ErrorMessage.Text = "The supplied e-mail could not be found"
        End If
    End Sub
    Protected Function generatePassword() As String

        ' This function will create a random password with 11 characters and return this password
        ' as "stringPassword".

        Dim arrPossibleChars As Char() = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789".ToCharArray()
        Dim intPasswordLength As Integer = 10
        Dim stringPassword As String = Nothing

        Dim rand As System.Random = New Random

        Dim i As Integer = 0
        For i = 0 To intPasswordLength
            Dim intRandom As Integer = rand.Next(arrPossibleChars.Length)
            stringPassword = stringPassword & arrPossibleChars(intRandom).ToString()
        Next

        Return stringPassword

    End Function
End Class
